// $Id: lock.C,v 1.2 2006/06/20 17:50:45 dvermeir Exp $

#include <string>
#include <iostream>
#include <pthread.h>

#include <dvthread/lock.h>
#include <dvthread/monitor.h>

Dv::Thread::Lock::Lock(Monitor& m, const std::string& msg, std::ostream* log): 
      monitor_(m), msg_(msg), log_(log) {
  if (log_)
    *log_ << pthread_self() << ": Dv::Thread::Lock::Lock on " << monitor_.name() << ": " << msg_ << std::endl;
  monitor_.enter(); 
  if (log_)
    *log_ << pthread_self() << ": Dv::Thread::Lock::Lock on " << monitor_.name() << ": ok" << std::endl;
}

Dv::Thread::Lock::~Lock() throw (std::runtime_error) {
  if (log_)
    *log_ << pthread_self() << ": Dv::Thread::Lock::~Lock on " << monitor_.name() << ": " << msg_ << std::endl;
  monitor_.exit(); 
  if (log_)
    *log_ << pthread_self() << ": Dv::Thread::Lock::~Lock on " << monitor_.name() << ": ok" << std::endl;
}

