// $Id: test-already-started.C,v 1.2 2006/06/24 09:39:28 dvermeir Exp $
#include <iostream>
#include <dvthread/thread.h>

#define TRACE std::cerr << pthread_self() << ": " << __FILE__ << "." << __LINE__ << std::endl;

class MyThread: public Dv::Thread::Thread {
  public:
    MyThread(): Thread() {}
    ~MyThread() { join(); }

    int main() {
      try {
        start();
      }
      catch (std::exception& e) {
        std::cerr << "expected exception: " << e.what() << std::endl;
        return 0;
      }
      return 1;
    }
};

int
main(int, char**) {
  try {
    // Dv::Thread::Thread::log = &std::cerr;
    MyThread t;
    t.start(); // should end abnormally
    t.join();
    if (t.status() != 0)
      throw std::runtime_error("Thread exited with unexpected status");
  }
  catch (std::exception& e) {
    std::cerr << "exception: " << e.what() << std::endl;
    return 1;
  }
  return 0;
}
