// $Id: test-bad-start.C,v 1.1 2006/06/24 09:39:28 dvermeir Exp $

/** Usually, this program will not run TestThread::main */

#include <iostream>
#include <dvthread/thread.h>

int ran = 0;

class TestThread: public Dv::Thread::Thread {
public:
  // no join in destructor!
  int main() {
    ran = 1;
    return 0;
  }
};

int
main(int,char**) {
  // Dv::Thread::Thread::log = &std::cerr;
  try {
    TestThread t;
    t.start();
    // no join: t is likely to be destroyed before it got a chance to run
    if (! ran)
      std::cerr << "Ok, main() did not run [no join()]" << std::endl;
    else
      std::cerr << "Ok, by chance, main() did run [no join()]" << std::endl;
    }
  catch (std::exception& e) {
    std::cerr << e.what() << std::endl;
    return 1;
    }
  return 0;
}
