// $Id: test-exit.C,v 1.1 2006/06/24 09:39:28 dvermeir Exp $

/** Program to demonstrate Thread::exit */

#include <string>
#include <iostream>
#include <dvthread/thread.h>

class TestThread: public Dv::Thread::Thread {
  public:
    void step(int i) {
      std::cerr << "step " << i << " ";
      if (i==3) {
        std::cerr << std::endl;
        exit(5);
      }
    }
  
    int main() {
      for (int i=0; i<4; ++i) {
        step(i);
      }
      return 0;
    }

};

int
main(int,char**) {
  // Dv::Thread::Thread::log = &std::cerr;
  try {
    TestThread t;
    t.start();
    t.join();
    if (t.status() != 5)
      throw std::runtime_error("unexpected status");
  }
  catch (std::exception& e) {
    std::cerr << e.what() << std::endl;
    return 1;
  }
  return 0;
}
