// $Id: test-kill.C,v 1.4 2006/06/24 09:39:28 dvermeir Exp $

/** Simple program to demonstrate Thread::kill and Thread::killed */

#include <string>
#include <iostream>
#include <stdexcept>
#include <unistd.h> // sleep, close
#include <dvthread/thread.h>

struct A {
  A() { std::cerr << "A::A()" << std::endl; }
  ~A() { std::cerr << "A::~A()" << std::endl; }
};


class TestThread: public Dv::Thread::Thread {
  public:
    bool dead;
    TestThread(): dead(false) {}
    ~TestThread() { join(); }
  
    int main() {
      A a;
      while (!dead) {
        std::cerr << "main.." << std::endl;;
        sleep(1);
      }
      return 0;
    }
  
    void killed() throw() {
      dead = true;
    }
};

int
main(int,char**) {
  // Dv::Thread::Thread::log = &std::cerr;
  try {
    TestThread t;
    t.start();
    t.kill();
    t.join();
    if (!t.dead)
      throw std::runtime_error("killed but not dead");
  }
  catch (std::exception& e) {
    std::cerr << "ERROR: " << e.what() << std::endl;
    return 1;
  }
  return 0;
}
