// $Id: test-limit.C,v 1.2 2006/06/24 09:39:28 dvermeir Exp $

#include <iostream>
#include <stdexcept>
#include <unistd.h> // sleep(int)

#include <dvthread/thread.h>

class MyThread: public Dv::Thread::Thread {
  public:
    // Constructor; n is the id of this thread.
    MyThread(unsigned int n): Thread(), n_(n), die_(false) {}
    // The function executed by this tread.
    int main() {
      while (!die_) {
        std::cerr << id() << " ";
        sleep(1);
      }
      return 0;
    }
     // Destructor. Wait for this thread to finish before we detroy it.
    ~MyThread() { 
      die_ = true;
      std::cerr << "MyThread::~MyThread # = " << id() << std::endl; 
      join(); 
      std::cerr << "MyThread::~MyThread # = " << id() << " done" << std::endl; 
    } 
    unsigned int id() const { return n_; }
  private:
    // Id of this thread
    unsigned int  n_;
    bool die_;
};

// Test determining limit number of threads that can be created.
int
main(int,char**) {
  unsigned int n_threads(0);
  try {
    while (true)
      (new MyThread(++n_threads))->start();
  }
  catch (std::exception& e) {
    std::cerr << e.what() << std::endl;
    std::cerr << "n_threads = " << n_threads << std::endl;
    return 0;
  }
  return 0;
}
