// $Id: test-suicide.C,v 1.5 2006/06/24 09:39:28 dvermeir Exp $

/** Test verifies that a thread cannot send a signal (Thread::kill) to itself */

#include <string>
#include <iostream>
#include <dvthread/thread.h>

#define TRACE std::cerr << pthread_self() << ": " << __FILE__ << "." << __LINE__ << std::endl;

class TestThread: public Dv::Thread::Thread {
  public:
    TestThread() {}
  
    int main() throw (int) {
      try {
        kill();
      }
      catch (std::exception& e) {
        std::cerr << "expected exception: " << e.what() << std::endl;
        return 0; 
      }
      return 1;
    }
};

int
main(int,char**) {
  // Dv::Thread::Thread::log = &std::cerr;
  try {
    TestThread t;
    t.start();
    t.join();
    return t.status();
  }
  catch (std::exception& e) {
    std::cerr << e.what() << std::endl;
    return 1;
  }
}
