// $Id: test-thread.C,v 1.5 2006/06/24 09:39:28 dvermeir Exp $

#include <iostream>
#include "./buffer.h"
#include "./reader.h"
#include "./writer.h"

// Test thread program. The test consists of a reader and a writer
// thread that read/write items to a buffer.
int
main(int,char**) {
  try {
    // Dv::Thread::Thread::log = &std::cerr;
    Buffer buf; // buffer containing items
    Reader r(buf,10); // takes items from buffer
    Writer w(buf,15); // writes items to buffer
  
    r.start();
    std::cerr << "reader started.." << std::endl;
    w.start();
    std::cerr << "writer started.." << std::endl;
  
    r.join();
    if (r.status() != 0)
      throw std::runtime_error("reader has unexpected status");
    w.join();
    if (w.status() != 1)
      throw std::runtime_error("reader has unexpected status");
  }
  catch (std::exception& e) {
    std::cerr << e.what() << std::endl;
    return 1;
  }
return 0;
}
