#ifndef	DV_THREAD_WRITER_H
#define	DV_THREAD_WRITER_H
// $Id: writer.h,v 1.6 2006/06/24 09:39:28 dvermeir Exp $
#include <dvthread/thread.h>
#include <unistd.h>
#include "buffer.h"

// A Thread class that writes 100 items to a buffer.
class Writer: public Dv::Thread::Thread {
  public:	
     // Constructor; n is the number of items to put.
    Writer(Buffer& buf, unsigned int n): Thread(), buffer_(buf), n_(n) {}
    // Main function of a Writer thread.
    int main() {
      std::cerr << "writer main, id = " << id() << std::endl;
      try {
        for (unsigned int i=0; (i<n_);++i)
          buffer_.put(i);
      }
      catch (std::exception& e) {
        std::cerr << e.what() << std::endl;
        return 1;
      }
      return 0;
    }
    // Destructor, join this thread first.
    virtual ~Writer() { std::cerr << "Writer::~Writer" << std::endl; }
  private:
     // Buffer to which items will be written.
    Buffer& buffer_;
    // Number of items to write.
    unsigned int n_;
};
#endif
